#ifndef __FLASH_H__
#define __FLASH_H__

#include "at32f403a_407_board.h"
#include "stdio.h"

/* the select type flash size(the unit is k) */
#define FLASH_SIZE  (*(unsigned int  *)0x1FFFF7E0)
  
/* the flash code size(the unit is k) */
#define FLASH_CODE_SIZE 83
  
/* 0:flash write disable,1:flash write enable */
#define FLASH_WREN 1

uint16_t flash_readhalfword(uint32_t faddr);
void flash_writelenbyte(uint32_t writeaddr,uint32_t datatowrite,uint16_t len);
uint32_t flash_readlenbyte(uint32_t readaddr,uint16_t len);
void flash_write(uint32_t writeaddr,uint16_t *pbuffer,uint16_t numtowrite);
void flash_read(uint32_t readaddr,uint16_t *pbuffer,uint16_t numtoread);

#endif

















